import cfg from "../src/inc/config.mjs";
import sql from "../src/inc/sql.mjs";
import { promises as fs } from "fs";
import { exec as _exec } from "child_process";
import fetch from "flumm-fetch-cookies";

const exec = cmd => new Promise((resolve, reject) => {
  _exec(cmd, { maxBuffer: 5e3 * 1024 }, (err, stdout, stderr) => {
    if(err)
      return reject(err);
    if(stderr)
      console.error(stderr);
    resolve({ stdout: stdout });
  });
});

const _args = process.argv.slice(2);
const _itemid = +_args[0] || 1;

const items = await sql('items').where('id', _itemid);//.where('mime', 'like', 'audio/%');
let count = 1;
let total = items.length;

for(let item of items) {
  const itemid = item.id;
  const filename = item.dest;
  const mime = item.mime;
  try {
    if(mime.startsWith('video/') || mime == 'image/gif')
      await exec(`ffmpegthumbnailer -i./public/b/${filename} -s1024 -o./tmp/${itemid}.png`);
    else if(mime.startsWith('image/') && mime != 'image/gif')
      await exec(`convert ./public/b/${filename} ./tmp/${itemid}.png`);
    else if(mime.startsWith('audio/')) {
      if(item.src.match(/soundcloud/)) {
        const cover = (await exec(`yt-dlp -f 'bv*[height<=720]+ba/b[height<=720] / wv*+ba/w' --get-thumbnail "${item.src}"`)).stdout.trim();
        if(!cover.match(/default_avatar/)) {
          try {
            await exec(`wget "${cover}" -O ./tmp/${itemid}.jpg`);
            const size = (await fs.stat(`./tmp/${itemid}.jpg`)).size;
            if(size >= 0)
              await exec(`convert ./tmp/${itemid}.jpg ./tmp/${itemid}.png`);
            await fs.unlink(`./tmp/${itemid}.jpg`);
          } catch(err) {}
        }
        else
          await exec(`ffmpeg -i ./public/b/${filename} -update 1 -map 0:v -map 0:1 -c copy ./tmp/${itemid}.png`);
      }
      else
        await exec(`ffmpeg -i ./public/b/${filename} -update 1 -map 0:v -map 0:1 -c copy ./tmp/${itemid}.png`);
      await fs.copyFile(`./tmp/${itemid}.png`, `./public/ca/${itemid}.png`);
    }

    await exec(`convert "./tmp/${itemid}.png" -resize "128x128^" -gravity center -crop 128x128+0+0 +repage ./public/t/${itemid}.png`);
    await fs.unlink(`./tmp/${itemid}.png`);

  } catch(err) {
    await fs.copyFile('./mugge.png', `./public/t/${itemid}.png`);
  }
  console.log(`current: ${itemid} (${count} / ${total})`);
  count++;
}

/*for(let item of items) {
  try {
    const itemid = item.id;
    const filename = item.dest;
    await exec(`ffmpegthumbnailer -i./public/b/${filename} -s1024 -o./debug/tmp/${itemid}`);
    await exec(`convert "./debug/tmp/${itemid}" -resize "128x128^" -gravity center -crop 128x128+0+0 +repage ./public/t/${itemid}.png`);
    await fs.unlink(`./debug/tmp/${itemid}`);
    console.log(`current: ${itemid} (${count} / ${total})`);
  } catch(err) {}
  count++;
};*/
